/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   paper-dialog.js
 */

import {NeonAnimationRunnerBehavior} from '@polymer/neon-animation/neon-animation-runner-behavior.js';

import {PaperDialogBehavior} from '@polymer/paper-dialog-behavior/paper-dialog-behavior.js';

import {Polymer} from '@polymer/polymer/lib/legacy/polymer-fn.js';

import {html} from '@polymer/polymer/lib/utils/html-tag.js';

import {LegacyElementMixin} from '@polymer/polymer/lib/legacy/legacy-element-mixin.js';

/**
 * Material design:
 * [Dialogs](https://www.google.com/design/spec/components/dialogs.html)
 *
 * `<paper-dialog>` is a dialog with Material Design styling and optional
 * animations when it is opened or closed. It provides styles for a header, content
 * area, and an action area for buttons. You can use the
 * `<paper-dialog-scrollable>` element (in its own repository) if you need a
 * scrolling content area. To autofocus a specific child element after opening the
 * dialog, give it the `autofocus` attribute. See `Polymer.PaperDialogBehavior` and
 * `Polymer.IronOverlayBehavior` for specifics.
 *
 * For example, the following code implements a dialog with a header, scrolling
 * content area and buttons. Focus will be given to the `dialog-confirm` button
 * when the dialog is opened.
 *
 *     <paper-dialog>
 *       <h2>Header</h2>
 *       <paper-dialog-scrollable>
 *         Lorem ipsum...
 *       </paper-dialog-scrollable>
 *       <div class="buttons">
 *         <paper-button dialog-dismiss>Cancel</paper-button>
 *         <paper-button dialog-confirm autofocus>Accept</paper-button>
 *       </div>
 *     </paper-dialog>
 *
 * ### Styling
 *
 * See the docs for `Polymer.PaperDialogBehavior` for the custom properties
 * available for styling this element.
 *
 * ### Animations
 *
 * Set the `entry-animation` and/or `exit-animation` attributes to add an animation
 * when the dialog is opened or closed. See the documentation in
 * [PolymerElements/neon-animation](https://github.com/PolymerElements/neon-animation)
 * for more info.
 *
 * For example:
 *
 *     <script type="module">
 *       import '@polymer/neon-animation/animations/fade-out-animation.js';
 *       import '@polymer/neon-animation/animations/scale-up-animation.js';
 *     </script>
 *
 *     <paper-dialog entry-animation="scale-up-animation"
 *                   exit-animation="fade-out-animation">
 *       <h2>Header</h2>
 *       <div>Dialog body</div>
 *     </paper-dialog>
 *
 * ### Accessibility
 *
 * See the docs for `Polymer.PaperDialogBehavior` for accessibility features
 * implemented by this element.
 */
interface PaperDialogElement extends PaperDialogBehavior, NeonAnimationRunnerBehavior, LegacyElementMixin, HTMLElement {
  _renderOpened(): void;
  _renderClosed(): void;
  _onNeonAnimationFinish(): void;
}

export {PaperDialogElement};

declare global {

  interface HTMLElementTagNameMap {
    "paper-dialog": PaperDialogElement;
  }
}
